"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = require("path");
const ramda_1 = require("ramda");
const content_types_1 = require("@ewizardjs/content-types");
async function default_1(systemSettings, baseDir) {
    const contentType = ramda_1.pathOr('', ['content', 'type'], systemSettings);
    const blocksDir = ramda_1.pathOr('', ['path', 'blocks'], systemSettings);
    const localBlocksDir = ramda_1.pathOr('', ['path', 'localBlocks'], systemSettings);
    const rootComponentPath = ramda_1.pathOr('', ['path', 'rootComponent'], systemSettings);
    const rootComponentLoaderConfig = {
        test: new RegExp(rootComponentPath),
        use: [
            {
                loader: 'editor-style-loader',
            },
        ],
    };
    const moduleLoaderConfig = {
        test: new RegExp(rootComponentPath),
        use: [
            {
                loader: 'module-style-loader',
            },
        ],
    };
    const blocksLoaderConfig = {
        test: /index\.vue$/,
        include: [path_1.resolve(baseDir, blocksDir), path_1.resolve(baseDir, localBlocksDir)],
        use: [
            {
                loader: 'editor-style-loader',
            },
        ],
    };
    switch (contentType) {
        case content_types_1.ContentTypes.EMAIL:
            return [
                rootComponentLoaderConfig,
                blocksLoaderConfig,
            ];
        case content_types_1.ContentTypes.MODULE:
            return [
                moduleLoaderConfig,
            ];
        default:
            return [];
    }
}
exports.default = default_1;
//# sourceMappingURL=get-style-loaders.js.map