"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DevBuilder = void 0;
const webpack_1 = __importStar(require("webpack"));
const webpack_dev_server_1 = __importDefault(require("webpack-dev-server"));
const util_1 = require("util");
const find_free_port_1 = __importDefault(require("find-free-port"));
const builder_1 = require("./builder");
class DevBuilder extends builder_1.Builder {
    async build(options = {}) {
        const compiler = await this.getCompiler(options);
        return util_1.promisify(compiler.run).call(compiler);
    }
    async serve(options = {}) {
        const port = await this.findPort();
        const server = await this.createServer(options);
        server.listen(port, () => {
            console.log(`\nServer is listening on port ${port}\n`);
        });
    }
    async createServer(options) {
        var _a;
        let config = await this.getDevConfig(Object.assign({ live: true }, options));
        if (options.layout) {
            config = await this.getLayoutConfig(options);
        }
        const serverConfig = {
            publicPath: '/',
            contentBase: this.options.presentationPath,
            hot: true,
            quiet: true,
            clientLogLevel: 'none',
            writeToDisk: (filePath) => !/hot-update\.(js|json)$/.test(filePath),
        };
        (_a = config.plugins) === null || _a === void 0 ? void 0 : _a.push(new webpack_1.HotModuleReplacementPlugin());
        webpack_dev_server_1.default.addDevServerEntrypoints(config, serverConfig);
        return new webpack_dev_server_1.default(webpack_1.default(config), serverConfig);
    }
    async findPort() {
        const [port] = await find_free_port_1.default(3000);
        return port;
    }
}
exports.DevBuilder = DevBuilder;
//# sourceMappingURL=devBuilder.js.map