"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.InjectEwizardjsAttributePlugin = void 0;
const InjectHtmlPlugin_1 = require("./InjectHtmlPlugin");
const PLUGIN_NAME = 'InjectEwizardjsAttributePlugin';
const INDEX = 'index.html';
const EWIZARDJS_ATTRIBUTE = 'ewizardjs-content';
class InjectEwizardjsAttributePlugin extends InjectHtmlPlugin_1.InjectHtmlPlugin {
    apply(compiler) {
        compiler.hooks.emit.tapPromise(PLUGIN_NAME, async (compilation) => {
            await this.ensureAssetExists(compilation);
            this.injectAttribute(compilation);
        });
    }
    async ensureAssetExists(compilation) {
        try {
            await super.ensureAssetExists(compilation, INDEX);
        }
        catch (_a) {
            const errorMessage = `${PLUGIN_NAME}: there is no html file to inject attribute`;
            compilation.errors.push(errorMessage);
            throw new Error(errorMessage);
        }
    }
    injectAttribute(compilation) {
        const $ = this.getParsedHtml(compilation, INDEX);
        $('body').attr(EWIZARDJS_ATTRIBUTE, '');
        this.updateAsset(compilation, INDEX, $.html({ normalizeWhitespace: true }));
    }
}
exports.InjectEwizardjsAttributePlugin = InjectEwizardjsAttributePlugin;
//# sourceMappingURL=InjectEwizardjsAttributePlugin.js.map