/// <reference types="rx-core" />
/// <reference types="rx-core-binding" />
/// <reference types="rx-lite" />
/// <reference types="rx-lite-aggregates" />
/// <reference types="rx-lite-backpressure" />
/// <reference types="rx-lite-coincidence" />
/// <reference types="rx-lite-experimental" />
/// <reference types="rx-lite-joinpatterns" />
/// <reference types="rx-lite-time" />
import { Target } from '../enums';
import { Observable } from 'rx';
import { BuilderOptions, StrategyEntries, CoreEntries, BuilderArguments, CommonBuilderContext, CornBuilderContext } from '@ewizardjs/builder-utils';
export interface DevBuilderOptions extends BuilderOptions {
    template?: boolean;
    live?: boolean;
    watch?: boolean;
    eslint?: EsLintOptions;
    target?: Target;
    layout?: string;
    currentTheme?: string;
    validate?: boolean;
}
export interface DevBuilderArguments extends DevBuilderOptions, BuilderArguments {
}
export interface CommonDevBuilderArguments extends DevBuilderArguments, StrategyEntries {
}
export interface CornDevBuilderArguments extends DevBuilderArguments, CoreEntries {
}
declare type CommonDevBuilderContext1 = CommonBuilderContext & CommonDevBuilderArguments;
export interface CommonDevBuilderContext extends CommonDevBuilderContext1 {
}
declare type CornDevBuilderContext1 = CornBuilderContext & CornDevBuilderArguments;
export interface CornDevBuilderContext extends CornDevBuilderContext1 {
}
export interface EsLintOptions {
    fix?: boolean;
}
export interface Watcher {
    start: (options: DevBuilderOptions) => Observable<any>;
    stop: () => Promise<any>;
}
export {};
