/// <reference types="webpack-dev-server" />
import webpack from 'webpack';
import { DevBuilderArguments, DevBuilderOptions } from 'src/interfaces';
export declare abstract class Builder {
    options: DevBuilderArguments;
    constructor(presentationPath: string);
    protected getDevConfig(options: DevBuilderOptions): Promise<webpack.Configuration>;
    protected getTemplatesConfig(options: DevBuilderOptions): Promise<webpack.Configuration>;
    protected getLayoutConfig(options: DevBuilderOptions): Promise<webpack.Configuration>;
    protected getCompiler(options: DevBuilderOptions): Promise<webpack.Compiler | webpack.MultiCompiler>;
}
